import { renderless, api } from "@xmweb-ui/vue-renderless/nav-menu/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import { iconSetting, iconChevronRight, iconSandwichCollapse, iconSandwichExpand } from "@xmweb-ui/vue-icon";
import { resolveComponent, openBlock, createElementBlock, normalizeClass, createBlock, resolveDynamicComponent, createCommentVNode, renderSlot, normalizeStyle, Fragment, renderList, withCtx, createTextVNode, toDisplayString, withDirectives, createElementVNode, vShow, createVNode, Transition } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  props: [].concat(props, ["data", "parentKey", "overflow", "beforeSkip", "fetchMenuData", "fields", "prevent", "allowFullUrl"]),
  components: {
    IconSetting: iconSetting(),
    IconChevronRight: iconChevronRight(),
    IconSandwichCollapse: iconSandwichCollapse(),
    IconSandwichExpand: iconSandwichExpand()
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = {
  class: "xm-nav-menu"
};
var _hoisted_2 = {
  key: 1,
  class: "slot-logo"
};
var _hoisted_3 = {
  key: 3,
  class: "slot-toolbar"
};
var _hoisted_4 = {
  key: 4,
  class: "slot-mobile-menu"
};
var _hoisted_5 = {
  key: 0,
  class: "more-menu"
};
var _hoisted_6 = {
  class: "group"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_icon_chevron_right = resolveComponent("icon-chevron-right");
  return openBlock(), createElementBlock("div", _hoisted_1, [/^(retract|fixed)$/.test(_ctx.overflow) ? (openBlock(), createElementBlock(
    "div",
    {
      key: 0,
      class: normalizeClass(["more-button", {
        mobile: _ctx.slots.mobileMenu
      }]),
      onMouseenter: _cache[0] || (_cache[0] = function($event) {
        return _ctx.showSubMenu(_ctx.state.data[0].children, {
          more: true
        });
      }),
      onMouseleave: _cache[1] || (_cache[1] = function() {
        return _ctx.willHideSubMenu && _ctx.willHideSubMenu.apply(_ctx, arguments);
      })
    },
    [(openBlock(), createBlock(resolveDynamicComponent(_ctx.state.showMore ? "IconSandwichExpand" : "IconSandwichCollapse")))],
    34
    /* CLASS, HYDRATE_EVENTS */
  )) : createCommentVNode("v-if", true), _ctx.slots.logo ? (openBlock(), createElementBlock("div", _hoisted_2, [renderSlot(_ctx.$slots, "logo")])) : createCommentVNode("v-if", true), _ctx.state.data && _ctx.state.data.length ? (openBlock(), createElementBlock(
    "ul",
    {
      key: 2,
      style: normalizeStyle(_ctx.state.menuStyle),
      class: "menu"
    },
    [(openBlock(true), createElementBlock(
      Fragment,
      null,
      renderList(_ctx.state.data, function(item, index) {
        return openBlock(), createElementBlock("li", {
          key: index
        }, [(openBlock(), createBlock(resolveDynamicComponent(_ctx.getTag(item)), {
          to: _ctx.getRoute(item),
          class: normalizeClass({
            active: index === _ctx.state.activeIndex,
            selected: index === _ctx.state.selectedIndex
          }),
          onMouseenter: function onMouseenter($event) {
            return _ctx.showSubMenu(item.children, {
              index
            }, $event);
          },
          onMouseleave: _ctx.willHideSubMenu,
          onClick: function onClick($event) {
            return _ctx.clickMenu(item, index);
          }
        }, {
          default: withCtx(function() {
            return [createTextVNode(
              toDisplayString(item.title),
              1
              /* TEXT */
            )];
          }),
          _: 2
          /* DYNAMIC */
        }, 1064, ["to", "class", "onMouseenter", "onMouseleave", "onClick"]))]);
      }),
      128
      /* KEYED_FRAGMENT */
    ))],
    4
    /* STYLE */
  )) : createCommentVNode("v-if", true), withDirectives(createElementVNode(
    "div",
    {
      style: normalizeStyle({
        marginLeft: _ctx.state.marginLeft + "px"
      }),
      class: "more",
      onMouseenter: _cache[2] || (_cache[2] = function($event) {
        return _ctx.showSubMenu(_ctx.state.more[0].children, {
          more: true
        });
      }),
      onMouseleave: _cache[3] || (_cache[3] = function() {
        return _ctx.willHideSubMenu && _ctx.willHideSubMenu.apply(_ctx, arguments);
      })
    },
    toDisplayString(_ctx.t("ui.navMenu.moreText")),
    37
    /* TEXT, STYLE, HYDRATE_EVENTS */
  ), [[vShow, _ctx.state.isShowMore]]), _ctx.slots.toolbar ? (openBlock(), createElementBlock("div", _hoisted_3, [renderSlot(_ctx.$slots, "toolbar")])) : createCommentVNode("v-if", true), _ctx.slots.mobileMenu ? (openBlock(), createElementBlock("div", _hoisted_4, [renderSlot(_ctx.$slots, "mobileMenu")])) : createCommentVNode("v-if", true), createVNode(Transition, {
    name: "xm-transition-zoom-in-top",
    mode: "out-in",
    persisted: ""
  }, {
    default: withCtx(function() {
      return [withDirectives(createElementVNode(
        "ul",
        {
          class: normalizeClass([[_ctx.state.popClass, {
            slide: _ctx.state.showPopmenu
          }], "popmenu xm-min-scrollbar"]),
          style: normalizeStyle(_ctx.state.popStyle),
          onMouseenter: _cache[4] || (_cache[4] = function() {
            return _ctx.stopHideSubMenu && _ctx.stopHideSubMenu.apply(_ctx, arguments);
          }),
          onMouseleave: _cache[5] || (_cache[5] = function() {
            return _ctx.willHideSubMenu && _ctx.willHideSubMenu.apply(_ctx, arguments);
          })
        },
        [_ctx.state.showMore ? (openBlock(), createElementBlock("li", _hoisted_5, [createElementVNode("ul", null, [(openBlock(true), createElementBlock(
          Fragment,
          null,
          renderList(_ctx.state.more, function(item, index) {
            return openBlock(), createElementBlock(
              "li",
              {
                key: index,
                class: normalizeClass({
                  active: index === _ctx.state.subActiveIndex,
                  selected: index === _ctx.state.moreItemSelectedIndex
                })
              },
              [(openBlock(), createBlock(resolveDynamicComponent(_ctx.getTag(item)), {
                to: _ctx.getRoute(item),
                class: normalizeClass({
                  showicon: item.children
                }),
                onMouseenter: function onMouseenter($event) {
                  return _ctx.setSubMenu(item.children, index);
                },
                onMouseleave: _ctx.leaveMoreMune,
                onClick: function onClick($event) {
                  return _ctx.clickMenu(item, index);
                }
              }, {
                default: withCtx(function() {
                  return [createTextVNode(
                    toDisplayString(item.title),
                    1
                    /* TEXT */
                  )];
                }),
                _: 2
                /* DYNAMIC */
              }, 1064, ["to", "class", "onMouseenter", "onMouseleave", "onClick"])), item.children ? (openBlock(), createBlock(_component_icon_chevron_right, {
                key: 0,
                class: "more-icon"
              })) : createCommentVNode("v-if", true)],
              2
              /* CLASS */
            );
          }),
          128
          /* KEYED_FRAGMENT */
        ))])])) : createCommentVNode("v-if", true), _ctx.state.subMenus && _ctx.state.subMenus.length ? (openBlock(), createElementBlock(
          "li",
          {
            key: 1,
            class: normalizeClass([{
              "full-width": !_ctx.state.showMore
            }, "sub-menu"])
          },
          [createElementVNode("ul", null, [(openBlock(true), createElementBlock(
            Fragment,
            null,
            renderList(_ctx.state.subMenus, function(group, index) {
              return openBlock(), createElementBlock(
                "li",
                {
                  key: index,
                  class: normalizeClass({
                    "col-xs-12 col-sm-6 col-md-4 col-lg-3 col-xl-2": _ctx.state.popClass !== "single"
                  })
                },
                [createElementVNode("ul", _hoisted_6, [createElementVNode(
                  "li",
                  {
                    class: normalizeClass(["xm-nav-menu__sub-menu-title", !!group.title ? "" : "xm-nav-menu__sub-menu-title-blank"])
                  },
                  [(openBlock(), createBlock(resolveDynamicComponent(_ctx.getTag(group)), {
                    to: _ctx.getRoute(group),
                    onClick: function onClick($event) {
                      return _ctx.clickMenu(group, -1, index);
                    },
                    class: normalizeClass({
                      selected: index === _ctx.state.subIndex && _ctx.state.subItemSelectedIndex === -1
                    })
                  }, {
                    default: withCtx(function() {
                      return [createTextVNode(
                        toDisplayString(group.title),
                        1
                        /* TEXT */
                      )];
                    }),
                    _: 2
                    /* DYNAMIC */
                  }, 1032, ["to", "onClick", "class"]))],
                  2
                  /* CLASS */
                ), (openBlock(true), createElementBlock(
                  Fragment,
                  null,
                  renderList(group.children, function(item, i) {
                    return openBlock(), createElementBlock(
                      "li",
                      {
                        key: i,
                        class: normalizeClass(["sub-item", !group.title && !_ctx.state.subMenu[i].children ? "only-secondary-title" : ""])
                      },
                      [(openBlock(), createBlock(resolveDynamicComponent(_ctx.getTag(item)), {
                        to: _ctx.getRoute(item),
                        onClick: function onClick($event) {
                          return _ctx.clickMenu(item, i, index);
                        },
                        class: normalizeClass({
                          selected: i === _ctx.state.subItemSelectedIndex && index === _ctx.state.subIndex
                        })
                      }, {
                        default: withCtx(function() {
                          return [createTextVNode(
                            toDisplayString(item.title),
                            1
                            /* TEXT */
                          )];
                        }),
                        _: 2
                        /* DYNAMIC */
                      }, 1032, ["to", "onClick", "class"]))],
                      2
                      /* CLASS */
                    );
                  }),
                  128
                  /* KEYED_FRAGMENT */
                ))])],
                2
                /* CLASS */
              );
            }),
            128
            /* KEYED_FRAGMENT */
          ))])],
          2
          /* CLASS */
        )) : createCommentVNode("v-if", true)],
        38
        /* CLASS, STYLE, HYDRATE_EVENTS */
      ), [[vShow, _ctx.state.showPopmenu]])];
    }),
    _: 1
    /* STABLE */
  })]);
}
var pc = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  pc as default
};
